LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL;

entity prog is
	port(pc: in std_logic_vector (3 downto 0);
		program_am_i_being: in std_logic;
		program_input_address: in std_logic_vector(3 downto 0);
		program_command: in std_logic_vector(7 downto 0);
		program_hilo_toggle: in std_logic;
		data: out std_logic_vector (14 downto 0));
end prog;

architecture abc of prog is
subtype memory_unit is std_logic_vector(14 downto 0);
type total_mem is array(15 downto 0) of memory_unit;
signal mem: total_mem;

begin
	process (program_am_i_being) begin
	if program_am_i_being = '1' then -- we're being programmed
		if program_hilo_toggle = '0' then  -- we're programming the low 8 bits
			case program_input_address is 

				when "0000" => mem(0)(7 downto 0) <= program_command;
				when "0001" => mem(1)(7 downto 0) <= program_command;
				when "0010" => mem(2)(7 downto 0) <= program_command;
				when "0011" => mem(3)(7 downto 0) <= program_command;
				when "0100" => mem(4)(7 downto 0) <= program_command;
				when "0101" => mem(5)(7 downto 0) <= program_command;
				when "0110" => mem(6)(7 downto 0) <= program_command;
				when "0111" => mem(7)(7 downto 0) <= program_command;
				when "1000" => mem(8)(7 downto 0) <= program_command;
				when "1001" => mem(9)(7 downto 0) <= program_command;
				when "1010" => mem(10)(7 downto 0) <= program_command;
				when "1011" => mem(11)(7 downto 0) <= program_command;
				when "1100" => mem(12)(7 downto 0) <= program_command;
				when "1101" => mem(13)(7 downto 0) <= program_command;
				when "1110" => mem(14)(7 downto 0) <= program_command;
				when others => mem(15)(7 downto 0) <= program_command;
			end case;			
		else								-- we're programming the high 8 bits
			case program_input_address is
				when "0000" => mem(0)(14 downto 8) <= program_command(6 downto 0);
				when "0001" => mem(1)(14 downto 8) <= program_command(6 downto 0);
				when "0010" => mem(2)(14 downto 8) <= program_command(6 downto 0);
				when "0011" => mem(3)(14 downto 8) <= program_command(6 downto 0);
				when "0100" => mem(4)(14 downto 8) <= program_command(6 downto 0);
				when "0101" => mem(5)(14 downto 8) <= program_command(6 downto 0);
				when "0110" => mem(6)(14 downto 8) <= program_command(6 downto 0);
				when "0111" => mem(7)(14 downto 8) <= program_command(6 downto 0);
				when "1000" => mem(8)(14 downto 8) <= program_command(6 downto 0);
				when "1001" => mem(9)(14 downto 8) <= program_command(6 downto 0);
				when "1010" => mem(10)(14 downto 8) <= program_command(6 downto 0);
				when "1011" => mem(11)(14 downto 8) <= program_command(6 downto 0);
				when "1100" => mem(12)(14 downto 8) <= program_command(6 downto 0);
				when "1101" => mem(13)(14 downto 8) <= program_command(6 downto 0);
				when "1110" => mem(14)(14 downto 8) <= program_command(6 downto 0);
				when others => mem(15)(14 downto 8) <= program_command(6 downto 0);
			end case;
		end if;  -- end the hi/lo bit if clause
		-- data <= "000000000000000"; 
	end if;
end process;



process (pc) begin
--	else 		-- we are not being programmed
		case pc is
			when "0000" => data <= mem(0);
			when "0001" => data <= mem(1);
			when "0010" => data <= mem(2);
			when "0011" => data <= mem(3);
			when "0100" => data <= mem(4);
			when "0101" => data <= mem(5);
			when "0110" => data <= mem(6);
			when "0111" => data <= mem(7);
			when "1000" => data <= mem(8);
			when "1001" => data <= mem(9);
			when "1010" => data <= mem(10);
			when "1011" => data <= mem(11);
			when "1100" => data <= mem(12);
			when "1101" => data <= mem(13);
			when "1110" => data <= mem(14);
			when others => data <= mem(15);
		end case;
	--end if;
end process;

end abc;

